<?php
/**
 * montonio/module-hire-purchase
 *
 * @category   montonio
 * @package    module-hire-purchase
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */
declare(strict_types=1);

namespace Montonio\Hirepurchase\Gateway\Payments\ResponseHandler;

use Magento\Sales\Api\Data\OrderInterface;

/**
 * Class responsible for handling API payments response.
 */
class ResponseHandlerAggregate implements ResponseHandlerInterface
{
    /**
     * @var HandlerPool
     */
    private $handlerPool;

    /**
     * @param HandlerPool $handlerPool
     */
    public function __construct(HandlerPool $handlerPool)
    {
        $this->handlerPool = $handlerPool;
    }

    /**
     * @inheritdoc
     */
    public function handle(OrderInterface $order, array $data): void
    {
        $this->handlerPool->getHandlerByStatus($data['status'])->handle($order, $data);
    }
}
