/**
 * montonio/module-hire-purchase
 *
 * @category   montonio
 * @package    module-hire-purchase
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */
define(
    [
        'underscore',
        'jquery',
        'Magento_Checkout/js/view/payment/default'
    ],
    function (
        _,
        jQuery,
        paymentComponent
    ) {
        'use strict';
        return paymentComponent.extend({
            defaults: {
                template: 'Montonio_Hirepurchase/payment/montonio'
            },
            getServiceDescription: function () {

                var logoPath = this.getServiceLogoPath();
                var display = this.getTitleDisplay();
                var result = this.methodCnf.serviceDescription;

                jQuery('#' + this.methodCnf.methodCode)
                    .parents('.payment-method')
                    .addClass('montonio-payment-method');

                if(display == 'logo_title' && !_.isUndefined(logoPath) && !_.isEmpty(logoPath)) {
                    jQuery('#' + this.methodCnf.methodCode)
                        .parents('.payment-method')
                        .find('.payment-method-description')
                        .addClass('montonio-payment-method-description')
                        .css({'background-image':'url(' + logoPath + ')'});
                } else if (display == 'logo_title') {
                    jQuery('#' + this.methodCnf.methodCode)
                        .parents('.payment-method')
                        .find('.payment-method-description')
                        .addClass('montonio-payment-method-description');
                }

                if(display == 'only_logo' || display == 'only_title') {
                    result = '';
                }

                if(display == 'only_logo' || display == 'only_title') {
                    jQuery('#' + this.methodCnf.methodCode)
                        .parents('.payment-method-title')
                        .find('label')
                        .addClass('montonio-logo-only')
                        .css({'background-image':'url(' + logoPath + ')'});
                }
                return result;
            },
            getServiceLogoPath: function () {
                return this.methodCnf.serviceLogoPath;
            },

            getTitle: function () {
                var title;
                if(this.methodCnf.title){
                    title = this.methodCnf.title;
                } else {
                    title = this.item.title;
                }
                return title;
            },

            getTitleDisplay: function () {
                var result = 'logo_title';
                if(!_.isUndefined(this.methodCnf.titleDisplayOption)) {
                    result = this.methodCnf.titleDisplayOption;
                }
                return result;
            }
        });
    }
);
